diff --git a/src/main/java/net/minecraft/client/render/blockentity/PistonBlockEntityRenderer.java b/src/main/java/net/minecraft/client/render/blockentity/PistonBlockEntityRenderer.java
index b595aab41..4677ed0c6 100644
--- a/src/main/java/net/minecraft/client/render/blockentity/PistonBlockEntityRenderer.java
+++ b/src/main/java/net/minecraft/client/render/blockentity/PistonBlockEntityRenderer.java
@@ -1,6 +1,7 @@
 package net.minecraft.client.render.blockentity;
 
 import net.minecraft.client.Minecraft;
+import net.minecraft.client.render.BlockEntityRenderDispatcher;
 import net.minecraft.client.render.Lighting;
 import net.minecraft.client.render.RenderBlocks;
 import net.minecraft.client.render.block.model.BlockModel;
@@ -11,23 +12,23 @@ import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.Blocks;
-import net.minecraft.core.block.piston.BasePistonBlock;
+import net.minecraft.core.block.entity.BlockEntity;
+import net.minecraft.core.block.piston.PistonBaseBlock;
 import net.minecraft.core.block.piston.MovingPistonBlockEntity;
 import net.minecraft.core.block.piston.PistonHeadBlock;
+import net.minecraft.core.block.piston.SteelPistonBaseBlock;
+import net.minecraft.core.world.BlocksContainer;
 import net.minecraft.core.world.World;
 import org.lwjgl.opengl.GL11;
 
-// Referenced classes of package net.minecraft.src:
-//            TileEntitySpecialRenderer, Block, TileEntityPiston, Tessellator,
-//            RenderHelper, RenderBlocks, BasePistonBlock, BlockPistonExtension,
-//            World, BlockEntity
-
 public class PistonBlockEntityRenderer extends BlockEntityRenderer<MovingPistonBlockEntity>
 {
-    private static final PistonHeadBlockModel blockModelPistonHead = (PistonHeadBlockModel) BlockModelDispatcher.getInstance().getDispatch(Blocks.PISTON_HEAD);
     private RenderBlocks renderBlocks;
     private final Minecraft mc;
 
+    private BlocksContainer container = null;
+    private RenderBlocks containerRenderBlock = null;
+
     public PistonBlockEntityRenderer()
     {
         mc = Minecraft.getMinecraft(this);
@@ -40,12 +41,16 @@ public class PistonBlockEntityRenderer extends BlockEntityRenderer<MovingPistonB
     }
 
     @Override
-	public void doRender(Tessellator tessellator, MovingPistonBlockEntity tileEntity, double x, double y, double z,
+	public void doRender(Tessellator tessellator, MovingPistonBlockEntity blockEntity, double x, double y, double z,
                          float partialTick)
     {
-        Block block = Block.blocksList[tileEntity.getMovedId()];
-        if(block != null && tileEntity.getProgress(partialTick) < 1.0F)
+        Block block = Block.blocksList[blockEntity.getMovedId()];
+        if(block != null && blockEntity.getProgress(partialTick) < 1.0F)
         {
+            if (container == null || container.world != blockEntity.worldObj) {
+                container = new BlocksContainer(blockEntity.worldObj);
+                containerRenderBlock = new RenderBlocks(container);
+            }
             TextureRegistry.blockAtlas.bind();
             Lighting.disable();
             GL11.glBlendFunc(GL11.GL_SRC_ALPHA, GL11.GL_ONE_MINUS_SRC_ALPHA);
@@ -59,31 +64,50 @@ public class PistonBlockEntityRenderer extends BlockEntityRenderer<MovingPistonB
                 GL11.glShadeModel(GL11.GL_FLAT);
             }
             tessellator.startDrawingQuads();
-            tessellator.setTranslation(((float)x - (float)tileEntity.x) + tileEntity.getXOff(partialTick), ((float)y - (float)tileEntity.y) + tileEntity.getYOff(partialTick), ((float)z - (float)tileEntity.z) + tileEntity.getZOff(partialTick));
-            tessellator.setColorOpaque(1, 1, 1);
-            if(block == Blocks.PISTON_HEAD && tileEntity.getProgress(partialTick) < 0.5F)
+            tessellator.setTranslation(((float)x - (float)blockEntity.x) + blockEntity.getXOff(partialTick), ((float)y - (float)blockEntity.y) + blockEntity.getYOff(partialTick), ((float)z - (float)blockEntity.z) + blockEntity.getZOff(partialTick));
+            if(block instanceof PistonHeadBlock && blockEntity.getProgress(partialTick) < 0.5F)
             {
                 BlockModel.setRenderBlocks(renderBlocks);
-                blockModelPistonHead.renderPistonHeadNoCulling(tessellator, (PistonHeadBlock) block, tileEntity.x, tileEntity.y, tileEntity.z, false);
+                ((PistonHeadBlockModel)BlockModelDispatcher.getInstance().getDispatch(block)).renderPistonHeadNoCulling(tessellator, (PistonHeadBlock) block, blockEntity.x, blockEntity.y, blockEntity.z, false);
             } else
-            if(tileEntity.isSourcePiston() && !tileEntity.isExtending())
+            if(blockEntity.isSourcePiston() && !blockEntity.isExtending())
             {
-                PistonBlockModel<BasePistonBlock> pistonBase = (PistonBlockModel) BlockModelDispatcher.getInstance().getDispatch(block);
+                PistonBlockModel<PistonBaseBlock> pistonBase = (PistonBlockModel) BlockModelDispatcher.getInstance().getDispatch(block);
                 BlockModel.setRenderBlocks(renderBlocks);
-                blockModelPistonHead.setFaceTextureOverride(pistonBase.getFaceTexture());
-                blockModelPistonHead.renderPistonHeadNoCulling(tessellator, (PistonHeadBlock) Blocks.PISTON_HEAD, tileEntity.x, tileEntity.y, tileEntity.z, tileEntity.getProgress(partialTick) < 0.5F);
-                blockModelPistonHead.setFaceTextureOverride(null);
-                tessellator.setTranslation((float)x - (float)tileEntity.x, (float)y - (float)tileEntity.y, (float)z - (float)tileEntity.z);
-                pistonBase.renderNoCulling(tessellator, tileEntity.x, tileEntity.y, tileEntity.z);
+                if (block instanceof SteelPistonBaseBlock) { // Todo remove this terrible hardcoded render code
+                    PistonHeadBlockModel blockModelPistonHead = ((PistonHeadBlockModel) BlockModelDispatcher.getInstance().getDispatch(Blocks.PISTON_HEAD_STEEL));
+                    blockModelPistonHead.setFaceTextureOverride(pistonBase.getFaceTexture());
+                    blockModelPistonHead.renderPistonHeadNoCulling(tessellator, (PistonHeadBlock) Blocks.PISTON_HEAD_STEEL, blockEntity.x, blockEntity.y, blockEntity.z, blockEntity.getProgress(partialTick) < 0.5F);
+                    blockModelPistonHead.setFaceTextureOverride(null);
+                } else {
+                    PistonHeadBlockModel blockModelPistonHead = ((PistonHeadBlockModel) BlockModelDispatcher.getInstance().getDispatch(Blocks.PISTON_HEAD));
+                    blockModelPistonHead.setFaceTextureOverride(pistonBase.getFaceTexture());
+                    blockModelPistonHead.renderPistonHeadNoCulling(tessellator, (PistonHeadBlock) Blocks.PISTON_HEAD, blockEntity.x, blockEntity.y, blockEntity.z, blockEntity.getProgress(partialTick) < 0.5F);
+                    blockModelPistonHead.setFaceTextureOverride(null);
+                }
+                tessellator.setTranslation((float)x - (float)blockEntity.x, (float)y - (float)blockEntity.y, (float)z - (float)blockEntity.z);
+                pistonBase.renderNoCulling(tessellator, blockEntity.x, blockEntity.y, blockEntity.z);
             } else
             {
-                BlockModel.setRenderBlocks(renderBlocks);
-                BlockModel<Block> model = BlockModelDispatcher.getInstance().getDispatch(block);
-                model.renderNoCulling(tessellator, tileEntity.x, tileEntity.y, tileEntity.z);
+                BlockModel.setRenderBlocks(containerRenderBlock);
+                container.setBlock(blockEntity.x, blockEntity.y, blockEntity.z, block.id, blockEntity.getMovedData(), blockEntity.getMovedEntity());
+                BlockModelDispatcher.getInstance().getDispatch(block).renderNoCulling(Tessellator.instance, blockEntity.x, blockEntity.y, blockEntity.z);
+                container.setLightReferenceEntity(null);
+                container.clear();
             }
             tessellator.setTranslation(0.0D, 0.0D, 0.0D);
             tessellator.draw();
+
             Lighting.enableLight();
+
+            BlockEntity movedEntity = blockEntity.getMovedEntity();
+            BlockEntityRenderer<BlockEntity> renderer = BlockEntityRenderDispatcher.instance.getRenderer(movedEntity);
+            if (renderer != null) {
+                GL11.glPushMatrix();
+                GL11.glTranslatef(blockEntity.getXOff(partialTick), blockEntity.getYOff(partialTick), blockEntity.getZOff(partialTick));
+                renderer.doRender(tessellator, movedEntity, x, y, z, partialTick);
+                GL11.glPopMatrix();
+            }
         }
     }
 }
diff --git a/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureClock.java b/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureClock.java
index 657670f90..b130ffe5b 100644
--- a/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureClock.java
+++ b/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureClock.java
@@ -16,7 +16,7 @@ public class DynamicTextureClock extends DynamicTextureAbstractClock{
 		if(mc.theWorld != null && mc.thePlayer != null) {
 			float f = mc.theWorld.getCelestialAngle(1.0f);
 			d = -f * Math.PI * 2;
-			if(mc.theWorld.dimension == Dimension.nether) {
+			if(mc.theWorld.dimension == Dimension.NETHER) {
 				d = Math.random() * Math.PI * 2;
 			}
 		}
diff --git a/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureCompass.java b/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureCompass.java
index 48c85a82f..81fd413d3 100644
--- a/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureCompass.java
+++ b/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureCompass.java
@@ -70,7 +70,7 @@ public class DynamicTextureCompass extends DynamicTexture {
 			double var23 = (double)var21.x - this.mc.thePlayer.x;
 			double var25 = (double)var21.z - this.mc.thePlayer.z;
 			angle = (double)(this.mc.thePlayer.yRot - 90.0F) * PI / 180.0D - Math.atan2(var25, var23);
-			if(this.mc.theWorld.dimension == Dimension.nether) {
+			if(this.mc.theWorld.dimension == Dimension.NETHER) {
 				angle = Math.random() * PI * 2;
 			}
 		}
diff --git a/src/main/java/net/minecraft/client/render/entity/PlayerRenderer.java b/src/main/java/net/minecraft/client/render/entity/PlayerRenderer.java
index 98a3097de..4348b3fb2 100644
--- a/src/main/java/net/minecraft/client/render/entity/PlayerRenderer.java
+++ b/src/main/java/net/minecraft/client/render/entity/PlayerRenderer.java
@@ -36,6 +36,7 @@ public class PlayerRenderer extends MobRenderer<Player>
     private final BipedModel modelArmor;
 
     private BlocksContainer container = null;
+    private RenderBlocks containerRenderBlock = null;
 
     public PlayerRenderer()
     {
@@ -147,6 +148,7 @@ public class PlayerRenderer extends MobRenderer<Player>
             BlockEntity.CarriedBlock carriedBlock = (BlockEntity.CarriedBlock)player.getHeldObject();
             if (container == null || container.world != player.world) {
                 container = new BlocksContainer(player.world);
+                containerRenderBlock = new RenderBlocks(container);
             }
 
             Tessellator tessellator = Tessellator.instance;
@@ -170,7 +172,7 @@ public class PlayerRenderer extends MobRenderer<Player>
             int blockY = MathHelper.floor(player.y) + 1;
             int blockZ = MathHelper.floor(player.z);
 
-            BlockModel.setRenderBlocks(new RenderBlocks(container));
+            BlockModel.setRenderBlocks(containerRenderBlock);
             tessellator.startDrawingQuads();
             tessellator.setTranslation(-blockX -0.5, -blockY -0.5, -blockZ -0.5);
 
diff --git a/src/main/java/net/minecraft/core/block/BedBlock.java b/src/main/java/net/minecraft/core/block/BedBlock.java
index 1dd845d5e..47deb8e57 100644
--- a/src/main/java/net/minecraft/core/block/BedBlock.java
+++ b/src/main/java/net/minecraft/core/block/BedBlock.java
@@ -119,7 +119,7 @@ public class BedBlock extends Block {
 	}
 
 	@Override
-	public int getPistonPushReaction() {
+	public int getPistonPushReaction(World world, int x, int y, int z) {
 		return 1;
 	}
 
diff --git a/src/main/java/net/minecraft/core/block/Block.java b/src/main/java/net/minecraft/core/block/Block.java
index c0cb1f72c..c1172e626 100644
--- a/src/main/java/net/minecraft/core/block/Block.java
+++ b/src/main/java/net/minecraft/core/block/Block.java
@@ -11,7 +11,6 @@ import java.util.function.Supplier;
 
 import net.minecraft.core.block.support.FullSupport;
 import net.minecraft.core.block.support.ISupport;
-import net.minecraft.core.block.support.PartialSupport;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
@@ -704,7 +703,7 @@ public class Block
         return this;
     }
 
-    public int getPistonPushReaction()
+    public int getPistonPushReaction(World world, int x, int y, int z)
     {
         return blockMaterial.getPushReaction();
     }
